Index: pjproject/main/pjlib-util/build/Makefile
===================================================================
--- pjproject/main/pjlib-util/build/Makefile	(revision 32)
+++ pjproject/main/pjlib-util/build/Makefile	(revision 33)
@@ -1,55 +1,3 @@
-#
-# Include host/target/compiler selection.
-# This will export CC_NAME, MACHINE_NAME, OS_NAME, and HOST_NAME variables.
-#
-include ../../build.mak
-
-#
-# Include global compiler specific definitions
-#
-include ../../build/cc-$(CC_NAME).mak
-
-#
-# (Optionally) Include compiler specific configuration that is
-# specific to this project. This configuration file is
-# located in this directory.
-#
--include cc-$(CC_NAME).mak
-
-#
-# Include global machine specific definitions
-#
-include ../../build/m-$(MACHINE_NAME).mak
--include m-$(MACHINE_NAME).mak
-
-#
-# Include target OS specific definitions
-#
-include ../../build/os-$(OS_NAME).mak
-
-#
-# (Optionally) Include target OS specific configuration that is
-# specific to this project. This configuration file is
-# located in this directory.
-#
--include os-$(OS_NAME).mak
-
-#
-# Include host specific definitions
-#
-include ../../build/host-$(HOST_NAME).mak
-
-#
-# (Optionally) Include host specific configuration that is
-# specific to this project. This configuration file is
-# located in this directory.
-#
--include host-$(HOST_NAME).mak
-
-#
-# Include global user configuration, if any
-#
--include ../../user.mak
-
+include ../../build/common.mak
 
 RULES_MAK := ../../build/rules.mak
Index: pjproject/main/pjlib-util/build/pjlib_util.dsp
===================================================================
--- pjproject/main/pjlib-util/build/pjlib_util.dsp	(revision 33)
+++ pjproject/main/pjlib-util/build/pjlib_util.dsp	(revision 33)
@@ -0,0 +1,136 @@
+# Microsoft Developer Studio Project File - Name="pjlib_util" - Package Owner=<4>
+# Microsoft Developer Studio Generated Build File, Format Version 6.00
+# ** DO NOT EDIT **
+
+# TARGTYPE "Win32 (x86) Static Library" 0x0104
+
+CFG=pjlib_util - Win32 Debug
+!MESSAGE This is not a valid makefile. To build this project using NMAKE,
+!MESSAGE use the Export Makefile command and run
+!MESSAGE 
+!MESSAGE NMAKE /f "pjlib_util.mak".
+!MESSAGE 
+!MESSAGE You can specify a configuration when running NMAKE
+!MESSAGE by defining the macro CFG on the command line. For example:
+!MESSAGE 
+!MESSAGE NMAKE /f "pjlib_util.mak" CFG="pjlib_util - Win32 Debug"
+!MESSAGE 
+!MESSAGE Possible choices for configuration are:
+!MESSAGE 
+!MESSAGE "pjlib_util - Win32 Release" (based on "Win32 (x86) Static Library")
+!MESSAGE "pjlib_util - Win32 Debug" (based on "Win32 (x86) Static Library")
+!MESSAGE 
+
+# Begin Project
+# PROP AllowPerConfigDependencies 0
+# PROP Scc_ProjName ""
+# PROP Scc_LocalPath ""
+CPP=cl.exe
+RSC=rc.exe
+
+!IF  "$(CFG)" == "pjlib_util - Win32 Release"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 0
+# PROP BASE Output_Dir "./output/pjlib-util-i386-win32-vc6-release"
+# PROP BASE Intermediate_Dir "./output/pjlib-util-i386-win32-vc6-release"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 0
+# PROP Output_Dir "./output/pjlib-util-i386-win32-vc6-release"
+# PROP Intermediate_Dir "./output/pjlib-util-i386-win32-vc6-release"
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "../include" /I "../../pjlib/include" /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /YX /FD /c
+# ADD BASE RSC /l 0x409 /d "NDEBUG"
+# ADD RSC /l 0x409 /d "NDEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LIB32=link.exe -lib
+# ADD BASE LIB32 /nologo
+# ADD LIB32 /nologo /out:"../lib/pjlib-util-i386-win32-vc6-release.lib"
+
+!ELSEIF  "$(CFG)" == "pjlib_util - Win32 Debug"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 1
+# PROP BASE Output_Dir "./output/pjlib-util-i386-win32-vc6-debug"
+# PROP BASE Intermediate_Dir "./output/pjlib-util-i386-win32-vc6-debug"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 1
+# PROP Output_Dir "./output/pjlib-util-i386-win32-vc6-debug"
+# PROP Intermediate_Dir "./output/pjlib-util-i386-win32-vc6-debug"
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
+# ADD CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib/include" /D "_DEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /YX /FD /GZ /c
+# ADD BASE RSC /l 0x409 /d "_DEBUG"
+# ADD RSC /l 0x409 /d "_DEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LIB32=link.exe -lib
+# ADD BASE LIB32 /nologo
+# ADD LIB32 /nologo /out:"../lib/pjlib-util-i386-win32-vc6-debug.lib"
+
+!ENDIF 
+
+# Begin Target
+
+# Name "pjlib_util - Win32 Release"
+# Name "pjlib_util - Win32 Debug"
+# Begin Group "Source Files"
+
+# PROP Default_Filter "cpp;c;cxx;rc;def;r;odl;idl;hpj;bat"
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\md5.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\scanner.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\stun.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\stun_client.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\symbols.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util\xml.c"
+# End Source File
+# End Group
+# Begin Group "Header Files"
+
+# PROP Default_Filter "h;hpp;hxx;hm;inl"
+# Begin Source File
+
+SOURCE="..\include\pjlib-util\md5.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjlib-util.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjlib-util\scanner.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjlib-util\stun.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjlib-util\xml.h"
+# End Source File
+# End Group
+# End Target
+# End Project
Index: pjproject/main/pjlib-util/build/pjlib_util.dsw
===================================================================
--- pjproject/main/pjlib-util/build/pjlib_util.dsw	(revision 33)
+++ pjproject/main/pjlib-util/build/pjlib_util.dsw	(revision 33)
@@ -0,0 +1,75 @@
+Microsoft Developer Studio Workspace File, Format Version 6.00
+# WARNING: DO NOT EDIT OR DELETE THIS WORKSPACE FILE!
+
+###############################################################################
+
+Project: "pjlib"="..\..\pjlib\build\pjlib.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjlib_test"="..\..\pjlib\build\pjlib_test.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+    begin source code control
+    "$/pjproject/pjlib/build", UIAAAAAA
+    ..\..\pjlib\build
+    end source code control
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjlib_util"=".\pjlib_util.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjlib_util_test"=".\pjlib_util_test.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+    Begin Project Dependency
+    Project_Dep_Name pjlib_util
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjlib
+    End Project Dependency
+}}}
+
+###############################################################################
+
+Global:
+
+Package=<5>
+{{{
+}}}
+
+Package=<3>
+{{{
+}}}
+
+###############################################################################
+
Index: pjproject/main/pjlib-util/build/pjlib_util_test.dsp
===================================================================
--- pjproject/main/pjlib-util/build/pjlib_util_test.dsp	(revision 33)
+++ pjproject/main/pjlib-util/build/pjlib_util_test.dsp	(revision 33)
@@ -0,0 +1,114 @@
+# Microsoft Developer Studio Project File - Name="pjlib_util_test" - Package Owner=<4>
+# Microsoft Developer Studio Generated Build File, Format Version 6.00
+# ** DO NOT EDIT **
+
+# TARGTYPE "Win32 (x86) Console Application" 0x0103
+
+CFG=pjlib_util_test - Win32 Debug
+!MESSAGE This is not a valid makefile. To build this project using NMAKE,
+!MESSAGE use the Export Makefile command and run
+!MESSAGE 
+!MESSAGE NMAKE /f "pjlib_util_test.mak".
+!MESSAGE 
+!MESSAGE You can specify a configuration when running NMAKE
+!MESSAGE by defining the macro CFG on the command line. For example:
+!MESSAGE 
+!MESSAGE NMAKE /f "pjlib_util_test.mak" CFG="pjlib_util_test - Win32 Debug"
+!MESSAGE 
+!MESSAGE Possible choices for configuration are:
+!MESSAGE 
+!MESSAGE "pjlib_util_test - Win32 Release" (based on "Win32 (x86) Console Application")
+!MESSAGE "pjlib_util_test - Win32 Debug" (based on "Win32 (x86) Console Application")
+!MESSAGE 
+
+# Begin Project
+# PROP AllowPerConfigDependencies 0
+# PROP Scc_ProjName ""
+# PROP Scc_LocalPath ""
+CPP=cl.exe
+RSC=rc.exe
+
+!IF  "$(CFG)" == "pjlib_util_test - Win32 Release"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 0
+# PROP BASE Output_Dir "./output/pjlib-util-test-i386-win32-vc6-release"
+# PROP BASE Intermediate_Dir "./output/pjlib-util-test-i386-win32-vc6-release"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 0
+# PROP Output_Dir "./output/pjlib-util-test-i386-win32-vc6-release"
+# PROP Intermediate_Dir "./output/pjlib-util-test-i386-win32-vc6-release"
+# PROP Ignore_Export_Lib 0
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "../include" /I "../../pjlib/include" /D "NDEBUG" /D "WIN32" /D "_CONSOLE" /D "_MBCS" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /YX /FD /c
+# ADD BASE RSC /l 0x409 /d "NDEBUG"
+# ADD RSC /l 0x409 /d "NDEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LINK32=link.exe
+# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386
+# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386 /out:"../bin/pjlib-util-test-i386-win32-vc6-release"
+
+!ELSEIF  "$(CFG)" == "pjlib_util_test - Win32 Debug"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 1
+# PROP BASE Output_Dir "./output/pjlib-util-test-i386-win32-vc6-debug"
+# PROP BASE Intermediate_Dir "./output/pjlib-util-test-i386-win32-vc6-debug"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 1
+# PROP Output_Dir "./output/pjlib-util-test-i386-win32-vc6-debug"
+# PROP Intermediate_Dir "./output/pjlib-util-test-i386-win32-vc6-debug"
+# PROP Ignore_Export_Lib 0
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_CONSOLE" /D "_MBCS" /YX /FD /GZ /c
+# ADD CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /I "../include" /I "../../pjlib/include" /D "_DEBUG" /D "WIN32" /D "_CONSOLE" /D "_MBCS" /D PJ_WIN32=1 /D PJ_M_I386=1 /FR /YX /FD /GZ /c
+# ADD BASE RSC /l 0x409 /d "_DEBUG"
+# ADD RSC /l 0x409 /d "_DEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LINK32=link.exe
+# ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept
+# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /out:"../bin/pjlib-util-test-i386-win32-vc6-debug" /pdbtype:sept
+
+!ENDIF 
+
+# Begin Target
+
+# Name "pjlib_util_test - Win32 Release"
+# Name "pjlib_util_test - Win32 Debug"
+# Begin Group "Source Files"
+
+# PROP Default_Filter "cpp;c;cxx;rc;def;r;odl;idl;hpj;bat"
+# Begin Source File
+
+SOURCE="..\src\pjlib-util-test\main.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util-test\test.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjlib-util-test\xml.c"
+# End Source File
+# End Group
+# Begin Group "Header Files"
+
+# PROP Default_Filter "h;hpp;hxx;hm;inl"
+# Begin Source File
+
+SOURCE="..\src\pjlib-util-test\test.h"
+# End Source File
+# End Group
+# Begin Group "Resource Files"
+
+# PROP Default_Filter "ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe"
+# End Group
+# End Target
+# End Project